unit NewForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Mask, StdCtrls, Grids, Buttons, DataGrid, Main, dbvConst, ChildWin;

type
  TFormNew = class(TForm)
    DataGrid1: TDataGrid;
    GroupBox1: TGroupBox;
    btnUp: TBitBtn;
    btnDown: TBitBtn;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    btnAdd: TBitBtn;
    btnRemove: TBitBtn;
    btnDefNdx: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure DataGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAddClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnDefNdxClick(Sender: TObject);
  private
    { Private declarations }
    procedure SetFldType(var msg: TMessage); message SetType;
    procedure NumericCheck(var msg: TMessage); message CheckNum;
  public
    { Public declarations }
    procedure ClearLists;
    procedure LoadLists(aChild: TMDIChild);
  end;

  TDBaseFile = class
    aFile: file of byte;
    aBuffer: array of byte;
    procedure FixDBase(aName: string; aGrid: TDataGrid);
  end;

var
  FormNew: TFormNew;
  aDBaseFile: TDBaseFile;

implementation

{$R *.DFM}

uses IndexGen, Db;

procedure TformNew.FormActivate(Sender: TObject);
begin
  with DataGrid1 do begin
    if RowCount > 1 then
      Row := 1
    else
      Row := 0;
    {fi}
    Col := 0;
    SetFocus;
    end;
  {od with}
end;

procedure TformNew.btnUpClick(Sender: TObject);
var
  sTemp: string;
  iTemp: Integer;
  Cntr: Integer;
begin
  with DataGrid1 do
    if Row > 1 then begin
      iTemp := Row - 1;
      for Cntr := 0 to 4 do begin
        sTemp := Cells[Cntr,iTemp];
        Cells[Cntr,iTemp] := Cells[Cntr,Row];
        Cells[Cntr,Row] := sTemp;
        end;
      {od for}
      Row := iTemp;
      end;
    {fi}
  {od with}
end;

procedure TFormNew.btnDownClick(Sender: TObject);
var
  sTemp: string;
  iTemp: Integer;
  Cntr: Integer;
begin
  with DataGrid1 do
    if Row < DataGrid1.RowCount then begin
      iTemp := Row + 1;
      for Cntr := 0 to 4 do begin
        sTemp := Cells[Cntr,iTemp];
        Cells[Cntr,iTemp] := Cells[Cntr,Row];
        Cells[Cntr,Row] := sTemp;
        end;
      {od for}
      Row := iTemp;
      end;
    {fi}
  {od with}
end;

procedure TFormNew.DataGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key = VK_TAB) then begin
     if (DataGrid1.Col = 1) then
       PostMessage(Self.Handle,SetType,0,0)
     else if (DataGrid1.Col = 3) then
       PostMessage(Self.Handle,CheckNum,3,DataGrid1.Row)
     else if (DataGrid1.Col = 4) then
       PostMessage(Self.Handle,CheckNum,4,DataGrid1.Row);
     {fi}
     end;
   {fi}
end;  { TFormNew.DataGrid1KeyDown }

procedure TFormNew.SetFldType(var msg: TMessage);
type
  ColMask = set of (cmSize,cmDec);
var
  sTemp: string;
{func/proc}
  procedure SetCols(aType,aSize,aDec: string; aMask: ColMask);
  begin
    with DataGrid1 do begin
      Cells[2,Row] := aType;
      if cmSize in aMask then Cells[3,Row] := aSize;
      if cmDec in AMask then Cells[4,Row] := aDec;
      if not (cmSize in aMask) then
        Col := 3
      else begin
        RowCount := RowCount + 1;
        Row := Row + 1;
        Col := 0;
        end;
      {fi}
      end;
    {od with}
  end;
begin
  with DataGrid1 do begin
    sTemp := Cells[1,Row];
    if sTemp = 'Autoincrement' then SetCols('+','4','',[cmSize,cmDec])
    else if sTemp = 'Binary' then SetCols('B','10','',[cmSize,cmDec])
    else if sTemp = 'Currency' then SetCols('N','20','4',[cmSize,cmDec])
    else if sTemp = 'Date' then SetCols('D','8','',[cmSize,cmDec])
    else if sTemp = 'Float' then SetCols('F','','',[])
    else if sTemp = 'Integer' then SetCols('I','4','',[cmSize,cmDec])
    else if sTemp = 'Logical' then SetCols('L','1','',[cmSize,cmDec])
    else if sTemp = 'Memo' then SetCols('M','10','',[cmSize,cmDec])
    else if sTemp = 'Number' then SetCols('N','','',[])
    else if sTemp = 'OLE' then SetCols('G','10','',[cmSize,cmDec])
    else if sTemp = 'Real64' then SetCols('O','8','',[cmSize,cmDec])
    else if sTemp = 'String' then SetCols('C','','',[cmDec])
    else if sTemp = 'Timestamp' then SetCols('@','8','',[cmSize,cmDec])
    else begin
      ShowMessage(sTemp + ' is not a valid Field Type');
      Col := 1;
      end;
    {fi}
    end;
  {od with}
end;

procedure TFormNew.NumericCheck(var msg: TMessage);
var
  sTemp: string;
{func/proc}
  procedure NoDec(aSize: Integer);
  begin
    with DataGrid1 do begin
      if (msg.WParam = 3) and (IntValue[3,Msg.LParam] <> 4) then begin
        ShowMessage('Size for '+sTemp+' must be '+ IntToStr(aSize));
        Cells[3,Msg.LParam] := IntToStr(aSize);
        end
      else if (msg.WParam = 4) and (Length(Cells[4,Msg.LParam]) > 0) then begin
        ShowMessage('Dec for '+sTemp+' must be blank');
        Cells[4,Msg.LParam] := '';
        end;
      {fi}
      end;
    {od with}
  end;  { NoDEc}
  procedure NeedBoth;
  begin
    with DataGrid1 do begin
      if (msg.WParam = 3) and (IntValue[3,Msg.LParam] = 0) then begin
        ShowMessage('Size for '+sTemp+' must be specified');
        Col := 3;
        end;
      {fi}
      end;
    {od with}
  end;  {NeedBoth}
begin  { TFormNew.NumericCheck }
  with DataGrid1 do begin
    sTemp := Cells[1,Msg.LParam];
    if sTemp = 'Autoincrement' then
      NoDec(4)
    else if sTemp = 'Binary' then
      NoDec(10)
    else if sTemp = 'Currency' then
      with DataGrid1 do begin
        if (msg.WParam = 3) and (IntValue[3,Msg.LParam] <> 20) then begin
          ShowMessage('Size for '+sTemp+' must be 20');
          Cells[3,Msg.LParam] := '20';
          end
        else if (msg.WParam = 4) and (IntValue[3,Msg.LParam] <> 4) then begin
          ShowMessage('Dec for '+sTemp+' must be 4');
          Cells[4,Msg.LParam] := '4';
          end;
        {fi}
        end
      {od with}
    else if sTemp = 'Date' then
      NoDec(8)
    else if sTemp = 'Float' then
      NeedBoth
    else if sTemp = 'Integer' then
      NoDec(4)
    else if sTemp = 'Logical' then
      NoDec(1)
    else if sTemp = 'Memo' then
      NoDec(10)
   else if sTemp = 'Number' then
     NeedBoth
    else if sTemp = 'OLE' then
      NoDec(10)
    else if sTemp = 'Real64' then
      NoDec(8)
    else if sTemp = 'String' then
      with DataGrid1 do begin
            if (msg.WParam = 3) and (IntValue[3,Msg.LParam] = 0) then begin
          ShowMessage('Size for '+sTemp+' must be specified');
          Col := 3;
          end
        else if (msg.WParam = 4) and (Length(Cells[4,Msg.LParam]) > 0) then begin
          ShowMessage('Dec for '+sTemp+' must not be specified');
          Cells[4,Msg.LParam] := '';
          end;
        {fi}
        end
      {od with}
    else if sTemp = 'Timestamp' then
      NoDec(8)
    else begin
      ShowMessage(sTemp + ' is not a valid Field Type');
      Col := 1;
      end;
    {fi}
    end;
  {od with}
end;  { TFormNew.NumericCheck }

procedure TFormNew.btnAddClick(Sender: TObject);
begin
  DataGrid1.InsertRow(DataGrid1.Row);
end;

procedure TFormNew.btnRemoveClick(Sender: TObject);
var
  sTemp: string;
begin
  with DataGrid1 do begin
    sTemp := Cells[Col,Row];
    if Length(sTemp) = 0 then
      sTemp := 'the field';
    {fi}
    if MessageDlg('Are you shure that you want to remove ' +
        sTemp + '?', mtConfirmation,[mbYes,mbNo],0) = mrYes then
      DeleteRow(Row);
    {fi}
    end;
  {od for}
end;

procedure TFormNew.btnCancelClick(Sender: TObject);
begin
  if MessageDlg('Are you sure that you want to cancel?',
       mtConfirmation,[mbYes,mbNo],0) = mrYes then
     ModalResult := mrCancel
  else
     ModalResult := mrNone;
  {fi}
end;

procedure TDBaseFile.FixDBase(aName: string; aGrid: TDataGrid);
var
  aSize: Integer;
  Cntr: Integer;
  aByte: Byte;
{func/proc}
  procedure PatchFile(aField: Integer; aChar: Char);
  begin
    aBuffer[100+48*aField] := byte(aChar);
    aByte := StrToInt(aGrid.Cells[3,aField]);
    aBuffer[101+48*aField] := aByte;
    try
      aByte := StrToInt(aGrid.Cells[4,aField]);
    except
      aByte := 0;
    end;
    aBuffer[102+48*aField] := aByte;
  end;
begin
  AssignFile(aFile,aName);
  Reset(aFile);
  aSize := FileSize(aFile);
  SetLength(aBuffer,aSize);
  BlockRead(aFile,Pointer(Pointer(aBuffer)^),aSize);
  for Cntr := 0 to aGrid.RowCount - 1 do begin
      if aGrid.Cells[1,Cntr] = 'Float' then
        PatchFile(Cntr,'F')
      else if aGrid.Cells[1,Cntr] = 'Number' then
        PatchFile(Cntr,'N');
      {fi}
    end;
  {od for}
  Rewrite(aFile);
  BlockWrite(aFile,Pointer(Pointer(aBuffer)^),aSize);
  CloseFile(aFile);
  SetLength(aBuffer,0);
end;

procedure TFormNew.btnDefNdxClick(Sender: TObject);
begin
  MainForm.GenNDX := (formCreateNdx.ShowModal = mrOk);
end;

procedure TFormNew.ClearLists;
var
  Cntr: Integer;
begin
  with DataGrid1 do begin
    for Cntr := 0 to 4 do
      Cols[Cntr].Clear;
    {od for}
    RowCount := 1;
    Cells[0,0] := '';
    end;
  {od with}
  MainForm.GenNDX := False;
  with formCreateNDX.FieldGrid do begin
    Cols[0].Clear;
    RowCount := 2
    end;
  {od with}
  with formCreateNDX.IndexGrid do begin
    for Cntr := 0 to 2 do
      Cols[Cntr].Clear;
    {od for}
    RowCountMin := 2;
    RowCount := 2;
    end;
  {od with}
end;

procedure TFormNew.LoadLists(aChild: TMDIChild);
var
  DefsCntr: Integer;
  GridCntr: Integer;
  FldType: string;
  sTemp: string;
begin
  with aChild do begin
    DataGrid1.RowCount := Table1.FieldDefs.Count + 1;
    for DefsCntr := 0 to Table1.FieldDefs.Count - 1 do begin
      GridCntr := DefsCntr + 1;
      DataGrid1.Cells[0,GridCntr] := TrimRight(TableStructure[DefsCntr].Name);
      DataGrid1.Cells[2,GridCntr] := TableStructure[DefsCntr].FieldType;
      DataGrid1.Cells[3,GridCntr] := TableStructure[DefsCntr].Length;
      DataGrid1.Cells[4,GridCntr] := TableStructure[DefsCntr].Decimal;
      FldType := DataGrid1.Cells[2,GridCntr];
      if FldType = '+' then sTemp := 'Autoincrement'
      else if FldType = 'B' then sTemp := 'Binary'
      else if FldType = 'N' then begin
           if (DataGrid1.Cells[3,GridCntr] = '20') and
              (DataGrid1.Cells[4,GridCntr] = '4') then
             sTemp := 'Currency'
           else
             sTemp := 'Number';
           {fi}
           end
      else if FldType = 'D' then sTemp := 'Date'
      else if FldType = 'F' then sTemp := 'Float'
      else if FldType = 'I' then sTemp := 'Integer'
      else if FldType = 'L' then sTemp := 'Logical'
      else if FldType = 'M' then sTemp := 'Memo'
      else if FldType = 'G' then sTemp := 'OLE'
      else if FldType = 'O' then sTemp := 'Real64'
      else if FldType = 'C' then sTemp := 'String'
      else if FldType = '@' then sTemp := 'Timestamp'
      else sTemp := DataGrid1.Cells[2,GridCntr] + ' Unknown';
      {fi}
      DataGrid1.Cells[1,GridCntr] := sTemp;
      end;
    {od for}
    Table1.IndexDefs.Update;
    if Table1.IndexDefs.Count > 0 then begin
      MainForm.GenNDX := True;
      formCreateNdx.IndexGrid.RowCount := Table1.IndexDefs.Count+1;
      for DefsCntr := 0 to Table1.IndexDefs.Count-1 do begin
        GridCntr := DefsCntr + 1;
        formCreateNdx.IndexGrid.Cells[0,GridCntr] :=
             Table1.IndexDefs[DefsCntr].Name;
        formCreateNdx.IndexGrid.Cells[1,GridCntr] :=
             Table1.IndexDefs[DefsCntr].Fields;
        formCreateNdx.IndexGrid.Cells[2,GridCntr] :=
             Table1.IndexDefs[DefsCntr].Expression;
        end;
      {od for}
      end
    else begin
      MainForm.GenNDX := False;
      formCreateNdx.IndexGrid.RowCount := 1;
      end;
    {fi}
    end;
  {od with}
end;

initialization
  aDBaseFile := TDBaseFile.Create;

finalization
  aDBaseFile.Free;

end.

