unit TableStructure;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, PrintPrev;

type
  TFormStruct = class(TForm)
    StringGrid2: TStringGrid;
    TblName: TEdit;
    Label1: TLabel;
    StringGrid3: TStringGrid;
    btnOk: TBitBtn;
    btnPrint: TBitBtn;
    btnSave: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure btnIndexClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormStruct: TFormStruct;

implementation

{$R *.DFM}

uses
  ChildWin, Main, IndexDef, Printers;

procedure TFormStruct.FormActivate(Sender: TObject);
var
  Cntr: Integer;
  Limit: Integer;
begin
  with MainForm.ActiveMDIChild as TMDIChild do begin
    TblName.Text := Table1.TableName;
    StringGrid2.RowCount := High(TableStructure) + 2;
    StringGrid2.ColWidths[0] := 350;
    StringGrid2.ColWidths[1] := 45;
    StringGrid2.ColWidths[2] := 45;
    StringGrid2.ColWidths[3] := 45;
    StringGrid2.Cells[0,0] := 'Name';
    StringGrid2.Cells[1,0] := 'Type';
    StringGrid2.Cells[2,0] := 'Size';
    StringGrid2.Cells[3,0] := 'Decimal';
    for Cntr := 1 to High(TableStructure) + 1 do
      with TableStructure[Cntr - 1] do begin
        StringGrid2.Cells[0,Cntr] := Name;
        StringGrid2.Cells[1,Cntr] := FieldType;
        StringGrid2.Cells[2,Cntr] := Length;
        StringGrid2.Cells[3,Cntr] := Decimal;
        end;
      {od with}
    {od for}
    Table1.IndexDefs.Update;
    Limit := Table1.IndexDefs.Count;
    StringGrid3.RowCount := Limit+1;
    with StringGrid3 do begin
      ColWidths[1] := Width - ColWidths[0] - 20;
      Cells[0,0] := 'Index Name';
      Cells[1,0] := 'Index Definition';
      end;
    {od with}
    for Cntr := 1 to Limit{ -1} do begin
      StringGrid3.Cells[0,Cntr] := Table1.IndexDefs.Items[Cntr-1].Name;
      StringGrid3.Cells[1,Cntr] := Table1.IndexDefs.Items[Cntr-1].Fields;
      if Length(StringGrid3.Cells[1,Cntr]) = 0 then
        StringGrid3.Cells[1,Cntr] := Table1.IndexDefs.Items[Cntr-1].Expression;
      {fi}
      end;
    {od for}
    end;
  {od with}
end;

procedure TFormStruct.btnIndexClick(Sender: TObject);
begin
  formIndxDef.ShowModal;
end;

procedure TFormStruct.btnPrintClick(Sender: TObject);
begin
  MainForm.PrintStruct(TMDIChild(MainForm.ActiveMDIChild),True,True);
end;

procedure TFormStruct.btnSaveClick(Sender: TObject);
begin
  MainForm.SaveStruct(TMDIChild(MainForm.ActiveMDIChild),True,True);
end;

end.
